unit frmrtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,StdCtrls,
  ExtCtrls, Twofish;

type
  TfrmTestTTF = class(TForm)
    grpText: TGroupBox;
    btnDecrypt: TButton;
    btnEncrypt: TButton;
    edtTestText: TEdit;
    lblTestText: TLabel;
    grpFile: TGroupBox;
    btnFileEncrypt: TButton;
    odlFileEnc: TOpenDialog;
    sdlFileEnc: TSaveDialog;
    btnFileDecrypt: TButton;
    odlFileDec: TOpenDialog;
    sdlFileDec: TSaveDialog;
    rgrMode: TRadioGroup;
    grpKeySize: TGroupBox;
    rdb128: TRadioButton;
    rdb192: TRadioButton;
    rdb256: TRadioButton;
    edtVersion: TEdit;
    lblVersion: TLabel;
    Bevel1: TBevel;
    grpCBCMAC: TGroupBox;
    btmMakeMAC: TButton;
    edtCBCMAC: TEdit;
    rdbECB: TRadioButton;
    rdbCBC: TRadioButton;
    rdbCFB: TRadioButton;
    rdbOFB: TRadioButton;
    lblCBCMAC: TLabel;
    Twofish1: TTwofish;
    grpSelfTest: TGroupBox;
    btnSelfTest: TButton;
    procedure btnFileEncryptClick(Sender: TObject);
    procedure btnEncryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
    procedure btnFileDecryptClick(Sender: TObject);
    procedure rdbECBClick(Sender: TObject);
    procedure rdbCBCClick(Sender: TObject);
    procedure rdbCFBClick(Sender: TObject);
    procedure rdbOFBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rdb128Click(Sender: TObject);
    procedure rdb192Click(Sender: TObject);
    procedure rdb256Click(Sender: TObject);
    procedure btmMakeMACClick(Sender: TObject);
    procedure btnSelfTestClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTestTTF: TfrmTestTTF;

implementation

{$R *.DFM}

procedure TfrmTestTTF.btnFileEncryptClick(Sender: TObject);
begin
     Twofish1.LoadIVString('Init Vector');
     Twofish1.InitialiseString('Pass Phrase');
     if odlFileEnc.Execute then
     begin
          if sdlFileEnc.Execute then
          begin
               Twofish1.EncryptFile(odlFileEnc.FileName, sdlFileEnc.FileName);
          end;
     end;
end;

procedure TfrmTestTTF.btnEncryptClick(Sender: TObject);
var
     Tempstr: string;
begin
     Twofish1.LoadIVString('Init Vector');
     Twofish1.InitialiseString('Pass Phrase');
     Twofish1.EncryptString(edtTestText.Text,Tempstr);
     edtTestText.Text := TempStr;
end;

procedure TfrmTestTTF.btnDecryptClick(Sender: TObject);
var
     Tempstr: string;
begin
     Twofish1.InitialiseString('Pass Phrase');
     Twofish1.LoadIVString('Init Vector');
     Twofish1.DecryptString(edtTestText.Text,Tempstr);
     edtTestText.Text := TempStr;
end;

procedure TfrmTestTTF.btnFileDecryptClick(Sender: TObject);
begin
     Twofish1.LoadIVString('Init Vector');
     Twofish1.InitialiseString('Pass Phrase');
     if odlFileDec.Execute then
     begin
          if sdlFileDec.Execute then
          begin
               Twofish1.DecryptFile(odlFileDec.FileName, sdlFileDec.FileName);
          end;
     end;
end;

procedure TfrmTestTTF.rdbECBClick(Sender: TObject);
begin
     Twofish1.CipherMode := ECB;
end;

procedure TfrmTestTTF.rdbCBCClick(Sender: TObject);
begin
     Twofish1.CipherMode := CBC;
end;

procedure TfrmTestTTF.rdbCFBClick(Sender: TObject);
begin
     Twofish1.CipherMode := CFB;
end;

procedure TfrmTestTTF.rdbOFBClick(Sender: TObject);
begin
     Twofish1.CipherMode := OFB;
end;

procedure TfrmTestTTF.FormCreate(Sender: TObject);
begin
     // set the standard values
     Twofish1.CipherMode := ECB;
     Twofish1.KeySize := Small128;

     // get the version of the component and display it
     edtVersion.Text := Twofish1.GetVersion;
end;

procedure TfrmTestTTF.rdb128Click(Sender: TObject);
begin
     Twofish1.KeySize := Small128;
end;

procedure TfrmTestTTF.rdb192Click(Sender: TObject);
begin
     Twofish1.KeySize := Med192;
end;

procedure TfrmTestTTF.rdb256Click(Sender: TObject);
begin
     Twofish1.KeySize := Large256;
end;

procedure TfrmTestTTF.btmMakeMACClick(Sender: TObject);
var
     TempString: String;
begin
     // set the key and IV up
     Twofish1.InitialiseString('CBC-MAC secret key');
     Twofish1.LoadIVString('CBC-MAC secret Init Vector');

     // load the data into the internal RC6 registers
     // the result of the encryption can be thrown away
     // or better, the mac can be produced during the encryption
     // and simply read out at the end
     Twofish1.EncryptString(edtTestText.Text, TempString);

     // see if we are in CBC mode (needed for CBC-MAC)
     Twofish1.CBCMACString(TempString);

     // show the CBC-MAC
     edtCBCMAC.Text := TempString;
end;

procedure TfrmTestTTF.btnSelfTestClick(Sender: TObject);
const
     Key128: array[0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
     In128:  array[0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
     Out128: array[0..15] of Byte = ($9f, $58, $9f, $5c, $f6, $12, $2c, $32, $b6, $bf, $ec, $2f, $2a, $e8, $c3, $5a);

     Key192: array[0..23] of Byte = ($01, $23, $45, $67, $89, $ab, $cd, $ef, $fe, $dc, $ba, $98, $76, $54, $32, $10,
                                     $00, $11, $22, $33, $44, $55, $66, $77);
     In192:  array[0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
     Out192: array[0..15] of Byte = ($cf, $d1, $d2, $e5, $a9, $be, $9c, $df, $50, $1f, $13, $b8, $92, $bd, $22, $48);

     Key256: array[0..31] of Byte = ($01, $23, $45, $67, $89, $ab, $cd, $ef, $fe, $dc, $ba, $98, $76, $54, $32, $10,
                                     $00, $11, $22, $33, $44, $55, $66, $77, $88, $99, $aa, $bb, $cc, $dd, $ee, $ff);
     In256:  array[0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
     Out256: array[0..15] of Byte = ($37, $52, $7b, $e0, $05, $23, $34, $b8, $9f, $0c, $fc, $ca, $e8, $7c, $fa, $20);
var
     Input: TBlock;
     Output: TBLock;
     Output1: TBLock;
     i: integer;
begin
     // 128 bit key mode setup
     Fillchar(Input, BLOCKSIZE, #0);
     Fillchar(Output, BLOCKSIZE, #0);
     Twofish1.KeySize := Small128;
     Twofish1.InitialiseByte(Key128, Sizeof(Key128));
     Move(In128, Input, BLOCKSIZE);

     // do the encryption
     Twofish1.EncryptBlock(Input, Output);

     // check the result
     for i := 0 to 15 do
     begin
          if Output[i] <> Out128[i] then
          begin
               Showmessage('Selftest failed - encryption - 128 bit mode');
               Exit;
          end;
     end;

     // do the decryption
     Twofish1.DecryptBlock(Output, Output1);

     // check the result
     for i := 0 to 15 do
     begin
          if Output1[i] <> In128[i] then
          begin
               Showmessage('Selftest failed - decryption - 128 bit mode');
               Exit;
          end;
     end;

     // clear
     Twofish1.Burn;

     //192 bit keymode setup
     Fillchar(Input, BLOCKSIZE, #0);
     Fillchar(Output, BLOCKSIZE, #0);
     Twofish1.KeySize := Med192;
     Twofish1.InitialiseByte(Key192, Sizeof(Key192));
     Move(In192, Input, BLOCKSIZE);

     // do the encryption
     Twofish1.EncryptBlock(Input, Output);

     // check the result
     for i := 0 to 15 do
     begin
          if Output[i] <> Out192[i] then
          begin
               Showmessage('Selftest failed - encryption - 192 bit mode');
               Exit;
          end;
     end;

     // do the decryption
     Twofish1.DecryptBlock(Output, Output1);

     // check the result
     for i := 0 to 15 do
     begin
          if Output1[i] <> In192[i] then
          begin
               Showmessage('Selftest failed - decryption - 192 bit mode');
               Exit;
          end;
     end;

     // clear
     Twofish1.Burn;

     //256 bit keymode setup
     Fillchar(Input, BLOCKSIZE, #0);
     Fillchar(Output, BLOCKSIZE, #0);
     Twofish1.KeySize := Large256;
     Twofish1.InitialiseByte(Key256, Sizeof(Key256));
     Move(In256, Input, BLOCKSIZE);

     // do the encryption
     Twofish1.EncryptBlock(Input, Output);

     // check the result
     for i := 0 to 15 do
     begin
          if Output[i] <> Out256[i] then
          begin
               Showmessage('Selftest failed - encryption - 256 bit mode');
               Exit;
          end;
     end;

     // do the decryption
     Twofish1.DecryptBlock(Output, Output1);

     // check the result
     for i := 0 to 15 do
     begin
          if Output1[i] <> In256[i] then
          begin
               Showmessage('Selftest failed - decryption - 256 bit mode');
               Exit;
          end;
     end;

     // clear
     Twofish1.Burn;
     Twofish1.KeySize := Small128;

     // Success!
     ShowMessage('Self test passed!');
end;

end.
